# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

class JsonParser(object):
  def __init__(self, json_dict):
    self.json = json_dict

# Collected from bolt CDH3 NN on 10/18/2012.
SAMPLE = r"""
{
   "dfs":{
      "FSDirectory":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "sessionId":""
            },
            {
               "files_deleted":13294
            }
         ]
      ],
      "FSNamesystem":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "sessionId":""
            },
            {
               "BlockCapacity":524288,
               "BlocksTotal":57,
               "CapacityRemainingGB":169,
               "CapacityTotalGB":170,
               "CapacityUsedGB":0,
               "CorruptBlocks":0,
               "ExcessBlocks":0,
               "FilesTotal":41,
               "MissingBlocks":0,
               "PendingDeletionBlocks":0,
               "PendingReplicationBlocks":0,
               "ScheduledReplicationBlocks":0,
               "TotalLoad":28,
               "UnderReplicatedBlocks":0
            }
         ]
      ],
      "namenode":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "sessionId":""
            },
            {
               "AddBlockOps":13185,
               "CreateFileOps":13185,
               "DeleteFileOps":13187,
               "FileInfoOps":85,
               "FilesAppended":0,
               "FilesCreated":13190,
               "FilesInGetListingOps":113,
               "FilesRenamed":1,
               "GetBlockLocations":13182,
               "GetListingOps":13331,
               "JournalTransactionsBatchedInSync":1,
               "SafemodeTime":34922,
               "Syncs_avg_time":8,
               "Syncs_num_ops":39566,
               "Transactions_avg_time":0,
               "Transactions_num_ops":52753,
               "blockReport_avg_time":0,
               "blockReport_num_ops":887,
               "fsImageLoadTime":1725
            }
         ]
      ]
   },
   "jvm":{
      "metrics":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "processName":"NameNode",
               "sessionId":""
            },
            {
               "gcCount":4278,
               "gcTimeMillis":13335,
               "logError":0,
               "logFatal":0,
               "logInfo":170653,
               "logWarn":0,
               "maxMemoryM":270.25,
               "memHeapCommittedM":22.8125,
               "memHeapUsedM":11.36908,
               "memNonHeapCommittedM":34.1875,
               "memNonHeapUsedM":25.986458,
               "threadsBlocked":0,
               "threadsNew":0,
               "threadsRunnable":7,
               "threadsTerminated":0,
               "threadsTimedWaiting":14,
               "threadsWaiting":38
            }
         ]
      ]
   },
   "rpc":{
      "detailed-metrics":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "port":"8020"
            },
            {
               "addBlock_avg_time":3,
               "addBlock_num_ops":13185,
               "blockReceived_avg_time":0,
               "blockReceived_num_ops":39543,
               "blockReport_avg_time":0,
               "blockReport_num_ops":887,
               "blocksBeingWrittenReport_avg_time":0,
               "blocksBeingWrittenReport_num_ops":4,
               "complete_avg_time":7,
               "complete_num_ops":13182,
               "create_avg_time":11,
               "create_num_ops":13185,
               "delete_avg_time":10,
               "delete_num_ops":13187,
               "fsync_avg_time":0,
               "fsync_num_ops":5,
               "getBlockLocations_avg_time":0,
               "getBlockLocations_num_ops":13182,
               "getDatanodeReport_avg_time":18,
               "getDatanodeReport_num_ops":13178,
               "getEditLogSize_avg_time":0,
               "getEditLogSize_num_ops":2643,
               "getFileInfo_avg_time":0,
               "getFileInfo_num_ops":85,
               "getListing_avg_time":1,
               "getListing_num_ops":13331,
               "getProtocolVersion_avg_time":0,
               "getProtocolVersion_num_ops":39551,
               "getStats_avg_time":0,
               "getStats_num_ops":13178,
               "mkdirs_avg_time":0,
               "mkdirs_num_ops":5,
               "register_avg_time":0,
               "register_num_ops":4,
               "rename_avg_time":0,
               "rename_num_ops":1,
               "renewLease_avg_time":0,
               "renewLease_num_ops":118893,
               "rollEditLog_avg_time":0,
               "rollEditLog_num_ops":221,
               "rollFsImage_avg_time":0,
               "rollFsImage_num_ops":221,
               "sendHeartbeat_avg_time":0,
               "sendHeartbeat_num_ops":2113321,
               "setPermission_avg_time":0,
               "setPermission_num_ops":2,
               "setSafeMode_avg_time":0,
               "setSafeMode_num_ops":13179,
               "versionRequest_avg_time":0,
               "versionRequest_num_ops":4
            }
         ]
      ],
      "metrics":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com",
               "port":"8020"
            },
            {
               "NumOpenConnections":7,
               "ReceivedBytes":762786836,
               "RpcProcessingTime_avg_time":0,
               "RpcProcessingTime_num_ops":2434177,
               "RpcQueueTime_avg_time":0,
               "RpcQueueTime_num_ops":2434177,
               "SentBytes":366694933,
               "callQueueLen":0,
               "rpcAuthenticationFailures":0,
               "rpcAuthenticationSuccesses":0,
               "rpcAuthorizationFailures":0,
               "rpcAuthorizationSuccesses":147986
            }
         ]
      ]
   },
   "ugi":{
      "ugi":[
         [
            {
               "hostName":"centos62-25.ent.cloudera.com"
            },
            {
               "loginFailure_avg_time":0,
               "loginFailure_num_ops":0,
               "loginSuccess_avg_time":0,
               "loginSuccess_num_ops":0
            }
         ]
      ]
   }
}
"""
